int get_depth_index(int depth) {
//receives depth value
//returns index number of table

if (depth <= 40) return 0;
else if (depth <= 50) return 1;
else if (depth <= 60) return 2;
else if (depth <= 70) return 3;
else if (depth <= 80) return 4;
else if (depth <= 90) return 5;
else if (depth <= 100) return 6;
else if (depth <= 110) return 7;
else if (depth <= 120) return 8;
else if (depth <= 130) return 9;
else {
	//alert("Depth Index lookup error - NAUI");
	return -1;
}//end if

} //end get_depth_index


//---------------------------------------


int get_mdt(int depth_index) {
int tmp=-1, max=-1;

//search all items in array
for (int i=0; i < NAUI_table1_groups; i++) {
	tmp = NAUI_table1[depth_index][i];
	if (max < tmp)
		max = tmp;
}//end for

return max;
}//end get_mdt


//---------------------------------------


int get_t1_group(int depth_index, int adt) {
// returns dive group, A-L as 0-11

for (int i=0; i < NAUI_table1_groups; i++) {
	if (adt <= NAUI_table1[depth_index][i])
		return i;
}//end for
return -1;
}//end get_t1_group


//---------------------------------------


int sit_lookup(int divegroup, int sit) {
//returns new dive group based on SIT

for (int i=0; i < NAUI_table2_height; i++) {
	if ((sit <= NAUI_table2[divegroup][i]) && (sit > NAUI_table2[divegroup][i+1]))
		return i;
}//end for
return -1;
}//end sit_lookup


//---------------------------------------


int get_rnt(int divegroup, int depth_index) {

	return NAUI_table3_RNT[divegroup][depth_index];

}//end get_rnt


//---------------------------------------


int get_amdt(int divegroup, int depth_index) {

	return NAUI_table3_AMDT[divegroup][depth_index];

}//end get_amdt
