/****************************************************************************
** Form implementation generated from reading ui file 'qtdivecalcbase.ui'
**
** Created: Wed Aug 7 12:06:37 2002
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "qtdivecalcbase.h"

#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>

//Added by Ed
#include <stdlib.h>
//need stdio.h for sscanf
//#include <stdio.h>
#include <qstring.h>
#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qmessagebox.h>
//#include "divecalcprefs.h"
#include "NAUI-tables.h"
#include "calcfunctions.h"
//#include "errorfunctions.cpp"

/* 
 *  Constructs a DiveCalcBase which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
DiveCalcBase::DiveCalcBase( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{

//DEPTH_MAX=130, ADT_MAX=130, SIT_MAX=1440 - from NAUI-tables.h

    if ( !name )
	setName( "DiveCalcBase" );
    resize( 240, 310 ); 
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, sizePolicy().hasHeightForWidth() ) );
    setMinimumSize( QSize( 240, 310 ) );
    setMaximumSize( QSize( 240, 310 ) );
    setCaption( tr( "DiveCalc" ) );


//THIS SECTION ADDED BY ED--------------
MenuBar = new QMenuBar( this );  

ActionMenu = new QPopupMenu( this );
  MenuBar->insertItem( "&Action", ActionMenu );
  ActionMenu->insertItem( "&Calculate", this, SLOT( slotCalculate() ) );
  ActionMenu->insertItem( "C&lear", this, SLOT( slotClear() ) );
  ActionMenu->insertItem( "&Preferences", this, SLOT( slotPrefs() ) );

HelpMenu = new QPopupMenu( this );
  MenuBar->insertItem( "&Help", HelpMenu);
  HelpMenu->insertItem( "&Help", this, SLOT( slotHelp() ) );
  HelpMenu->insertItem( "&Definitions", this, SLOT( slotDefinitions() ) );
//  HelpMenu->insertSeparator();
  HelpMenu->insertItem( "&License", this, SLOT( slotLicense() ) );
  HelpMenu->insertItem( "&About", this, SLOT( slotAbout() ) );

//THIS SECTION ADDED BY ED--------------


    AMDTGroupBox = new QGroupBox( this, "AMDTGroupBox" );
    AMDTGroupBox->setGeometry( QRect( 5, 235, 230, 45 ) ); 
    QFont AMDTGroupBox_font(  AMDTGroupBox->font() );
    AMDTGroupBox_font.setBold( TRUE );
    AMDTGroupBox->setFont( AMDTGroupBox_font ); 
    AMDTGroupBox->setTitle( tr( "(A) M D T" ) );
    AMDTGroupBox->setAlignment( int( QGroupBox::AlignHCenter ) );
//    QToolTip::add(  AMDTGroupBox, tr( "(Adjusted) Maximum Dive Time" ) );

    CalculatePushButton = new QPushButton( AMDTGroupBox, "CalculatePushButton" );
    CalculatePushButton->setGeometry( QRect( 5, 15, 70, 25 ) ); 
    QFont CalculatePushButton_font(  CalculatePushButton->font() );
    CalculatePushButton->setFont( CalculatePushButton_font ); 
    CalculatePushButton->setFocusPolicy( QPushButton::StrongFocus );
    CalculatePushButton->setText( tr( "Calculate" ) );
QToolTip::add( CalculatePushButton, tr( "Calculate (Adjusted) Maximum Dive Time" ) );
//CalculatePushButton->setDefault( TRUE );
//CalculatePushButton->setAutoDefault( TRUE );

    AMDTLineEdit = new QLineEdit( AMDTGroupBox, "AMDTLineEdit" );
    AMDTLineEdit->setEnabled( TRUE );
    AMDTLineEdit->setGeometry( QRect( 80, 15, 40, 21 ) ); 
    QFont AMDTLineEdit_font(  AMDTLineEdit->font() );
    AMDTLineEdit_font.setPointSize( 14 );
    AMDTLineEdit_font.setBold( FALSE );
    AMDTLineEdit->setFont( AMDTLineEdit_font ); 
    AMDTLineEdit->setFocusPolicy( QLineEdit::NoFocus );
    AMDTLineEdit->setText( tr( "0" ) );
    AMDTLineEdit->setFrame( FALSE );
    AMDTLineEdit->setAlignment( int( QLineEdit::AlignHCenter ) );

    PrefsPushButton = new QPushButton( AMDTGroupBox, "PrefsPushButton" );
//Disables Prefs pushbutton
    PrefsPushButton->setEnabled( FALSE );
    PrefsPushButton->setGeometry( QRect( 180, 15, 45, 25 ) ); 
    QFont PrefsPushButton_font(  PrefsPushButton->font() );
    PrefsPushButton_font.setBold( FALSE );
    PrefsPushButton->setFont( PrefsPushButton_font ); 
    PrefsPushButton->setFocusPolicy( QPushButton::StrongFocus );
    PrefsPushButton->setText( tr( "Prefs" ) );

    ClearPushButton = new QPushButton( AMDTGroupBox, "ClearPushButton" );
    ClearPushButton->setGeometry( QRect( 125, 15, 50, 25 ) ); 
    QFont ClearPushButton_font(  ClearPushButton->font() );
    ClearPushButton_font.setBold( FALSE );
    ClearPushButton->setFont( ClearPushButton_font ); 
    ClearPushButton->setFocusPolicy( QPushButton::StrongFocus );
    ClearPushButton->setText( tr( "Clear" ) );
    QToolTip::add( ClearPushButton, tr( "Clear all values" ) );

    DiveGroupBox1 = new QGroupBox( this, "DiveGroupBox1" );
    DiveGroupBox1->setGeometry( QRect( 5, 25, 230, 70 ) ); 
    QFont DiveGroupBox1_font(  DiveGroupBox1->font() );
    DiveGroupBox1_font.setBold( TRUE );
    DiveGroupBox1->setFont( DiveGroupBox1_font ); 
    DiveGroupBox1->setTitle( tr( "Dive 1" ) );
    DiveGroupBox1->setAlignment( int( QGroupBox::AlignLeft ) );

    SITSpinBox1 = new QSpinBox( DiveGroupBox1, "SITSpinBox1" );
    SITSpinBox1->setGeometry( QRect( 175, 40, 50, 20 ) ); 
    SITSpinBox1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, SITSpinBox1->sizePolicy().hasHeightForWidth() ) );
    QFont SITSpinBox1_font(  SITSpinBox1->font() );
    SITSpinBox1_font.setBold( FALSE );
    SITSpinBox1->setFont( SITSpinBox1_font ); 
    SITSpinBox1->setWrapping( FALSE );
    SITSpinBox1->setMaxValue( SIT_MAX );
    SITSpinBox1->setValue( 0 );

    SITTextLabel1 = new QLabel( DiveGroupBox1, "SITTextLabel1" );
    SITTextLabel1->setGeometry( QRect( 150, 40, 20, 20 ) ); 
    QFont SITTextLabel1_font(  SITTextLabel1->font() );
    SITTextLabel1_font.setBold( FALSE );
    SITTextLabel1->setFont( SITTextLabel1_font ); 
    SITTextLabel1->setText( tr( "SIT" ) );
    QToolTip::add(  SITTextLabel1, tr( "Surface Interval Time" ) );

    TNTLineEdit1 = new QLineEdit( DiveGroupBox1, "TNTLineEdit1" );
    TNTLineEdit1->setGeometry( QRect( 110, 40, 31, 20 ) ); 
    QFont TNTLineEdit1_font(  TNTLineEdit1->font() );
    TNTLineEdit1_font.setBold( FALSE );
    TNTLineEdit1->setFont( TNTLineEdit1_font ); 
    TNTLineEdit1->setFocusPolicy( QLineEdit::NoFocus );
    TNTLineEdit1->setText( tr( "0" ) );
    TNTLineEdit1->setFrame( FALSE );
    TNTLineEdit1->setAlignment( int( QLineEdit::AlignHCenter ) );

    TNTTextLabel1 = new QLabel( DiveGroupBox1, "TNTTextLabel1" );
    TNTTextLabel1->setGeometry( QRect( 80, 40, 30, 20 ) ); 
    QFont TNTTextLabel1_font(  TNTTextLabel1->font() );
    TNTTextLabel1_font.setBold( FALSE );
    TNTTextLabel1->setFont( TNTTextLabel1_font ); 
    TNTTextLabel1->setText( tr( "TNT" ) );
    QToolTip::add(  TNTTextLabel1, tr( "Total Nitrogen Time" ) );

    RNTLineEdit1 = new QLineEdit( DiveGroupBox1, "RNTLineEdit1" );
    RNTLineEdit1->setGeometry( QRect( 40, 40, 31, 20 ) ); 
    QFont RNTLineEdit1_font(  RNTLineEdit1->font() );
    RNTLineEdit1_font.setBold( FALSE );
    RNTLineEdit1->setFont( RNTLineEdit1_font ); 
    RNTLineEdit1->setFocusPolicy( QLineEdit::NoFocus );
    RNTLineEdit1->setText( tr( "0" ) );
    RNTLineEdit1->setFrame( FALSE );
    RNTLineEdit1->setAlignment( int( QLineEdit::AlignHCenter ) );

    RNTTextLabel1 = new QLabel( DiveGroupBox1, "RNTTextLabel1" );
    RNTTextLabel1->setGeometry( QRect( 10, 40, 30, 20 ) ); 
    QFont RNTTextLabel1_font(  RNTTextLabel1->font() );
    RNTTextLabel1_font.setBold( FALSE );
    RNTTextLabel1->setFont( RNTTextLabel1_font ); 
    RNTTextLabel1->setText( tr( "RNT" ) );
    QToolTip::add(  RNTTextLabel1, tr( "Residual Nitrogen Time" ) );

    ADTTextLabel1 = new QLabel( DiveGroupBox1, "ADTTextLabel1" );
    ADTTextLabel1->setGeometry( QRect( 145, 15, 30, 20 ) ); 
    QFont ADTTextLabel1_font(  ADTTextLabel1->font() );
    ADTTextLabel1_font.setBold( FALSE );
    ADTTextLabel1->setFont( ADTTextLabel1_font ); 
    ADTTextLabel1->setText( tr( "ADT" ) );
    QToolTip::add(  ADTTextLabel1, tr( "Actual Dive Time" ) );

    ADTSpinBox1 = new QSpinBox( DiveGroupBox1, "ADTSpinBox1" );
    ADTSpinBox1->setGeometry( QRect( 175, 15, 50, 20 ) ); 
    ADTSpinBox1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, ADTSpinBox1->sizePolicy().hasHeightForWidth() ) );
    QFont ADTSpinBox1_font(  ADTSpinBox1->font() );
    ADTSpinBox1_font.setBold( FALSE );
    ADTSpinBox1->setFont( ADTSpinBox1_font ); 
    ADTSpinBox1->setWrapping( FALSE );
    ADTSpinBox1->setMaxValue( ADT_MAX );
    ADTSpinBox1->setValue( 0 );

    ftmTextLabel1 = new QLabel( DiveGroupBox1, "ftmTextLabel1" );
    ftmTextLabel1->setGeometry( QRect( 120, 15, 16, 20 ) ); 
    QFont ftmTextLabel1_font(  ftmTextLabel1->font() );
    ftmTextLabel1_font.setBold( FALSE );
    ftmTextLabel1->setFont( ftmTextLabel1_font ); 
    ftmTextLabel1->setText( tr( "ft." ) );

    DepthTextLabel1 = new QLabel( DiveGroupBox1, "DepthTextLabel1" );
    DepthTextLabel1->setGeometry( QRect( 20, 15, 40, 20 ) ); 
    QFont DepthTextLabel1_font(  DepthTextLabel1->font() );
    DepthTextLabel1_font.setBold( FALSE );
    DepthTextLabel1->setFont( DepthTextLabel1_font ); 
    DepthTextLabel1->setFrameShape( QLabel::NoFrame );
    DepthTextLabel1->setText( tr( "Depth:" ) );

    DepthSpinBox1 = new QSpinBox( DiveGroupBox1, "DepthSpinBox1" );
    DepthSpinBox1->setGeometry( QRect( 65, 15, 50, 20 ) ); 
    DepthSpinBox1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, DepthSpinBox1->sizePolicy().hasHeightForWidth() ) );
    QFont DepthSpinBox1_font(  DepthSpinBox1->font() );
    DepthSpinBox1_font.setBold( FALSE );
    DepthSpinBox1->setFont( DepthSpinBox1_font ); 
    DepthSpinBox1->setWrapping( FALSE );
    DepthSpinBox1->setMaxValue( DEPTH_MAX );
    DepthSpinBox1->setValue( 0 );

    DiveGroupBox2 = new QGroupBox( this, "DiveGroupBox2" );
    DiveGroupBox2->setGeometry( QRect( 5, 95, 230, 70 ) ); 
    QFont DiveGroupBox2_font(  DiveGroupBox2->font() );
    DiveGroupBox2_font.setBold( TRUE );
    DiveGroupBox2->setFont( DiveGroupBox2_font ); 
    DiveGroupBox2->setTitle( tr( "Dive 2" ) );
    DiveGroupBox2->setAlignment( int( QGroupBox::AlignLeft ) );

    RNTTextLabel2 = new QLabel( DiveGroupBox2, "RNTTextLabel2" );
    RNTTextLabel2->setGeometry( QRect( 10, 40, 28, 20 ) ); 
    QFont RNTTextLabel2_font(  RNTTextLabel2->font() );
    RNTTextLabel2_font.setBold( FALSE );
    RNTTextLabel2->setFont( RNTTextLabel2_font ); 
    RNTTextLabel2->setText( tr( "RNT" ) );
    QToolTip::add(  RNTTextLabel2, tr( "Residual Nitrogen Time" ) );

    RNTLineEdit2 = new QLineEdit( DiveGroupBox2, "RNTLineEdit2" );
    RNTLineEdit2->setGeometry( QRect( 40, 40, 31, 22 ) ); 
    QFont RNTLineEdit2_font(  RNTLineEdit2->font() );
    RNTLineEdit2_font.setBold( FALSE );
    RNTLineEdit2->setFont( RNTLineEdit2_font ); 
    RNTLineEdit2->setFocusPolicy( QLineEdit::NoFocus );
    RNTLineEdit2->setText( tr( "0" ) );
    RNTLineEdit2->setFrame( FALSE );
    RNTLineEdit2->setAlignment( int( QLineEdit::AlignHCenter ) );

    TNTTextLabel2 = new QLabel( DiveGroupBox2, "TNTTextLabel2" );
    TNTTextLabel2->setGeometry( QRect( 80, 40, 30, 20 ) ); 
    QFont TNTTextLabel2_font(  TNTTextLabel2->font() );
    TNTTextLabel2_font.setBold( FALSE );
    TNTTextLabel2->setFont( TNTTextLabel2_font ); 
    TNTTextLabel2->setText( tr( "TNT" ) );
    QToolTip::add(  TNTTextLabel2, tr( "Total Nitrogen Time" ) );

    TNTLineEdit2 = new QLineEdit( DiveGroupBox2, "TNTLineEdit2" );
    TNTLineEdit2->setGeometry( QRect( 110, 40, 31, 22 ) ); 
    QFont TNTLineEdit2_font(  TNTLineEdit2->font() );
    TNTLineEdit2_font.setBold( FALSE );
    TNTLineEdit2->setFont( TNTLineEdit2_font ); 
    TNTLineEdit2->setFocusPolicy( QLineEdit::NoFocus );
    TNTLineEdit2->setText( tr( "0" ) );
    TNTLineEdit2->setFrame( FALSE );
    TNTLineEdit2->setAlignment( int( QLineEdit::AlignHCenter ) );

    SITTextLabel2 = new QLabel( DiveGroupBox2, "SITTextLabel2" );
    SITTextLabel2->setGeometry( QRect( 150, 40, 20, 20 ) ); 
    QFont SITTextLabel2_font(  SITTextLabel2->font() );
    SITTextLabel2_font.setBold( FALSE );
    SITTextLabel2->setFont( SITTextLabel2_font ); 
    SITTextLabel2->setText( tr( "SIT" ) );
    QToolTip::add(  SITTextLabel2, tr( "Surface Interval Time" ) );

    SITSpinBox2 = new QSpinBox( DiveGroupBox2, "SITSpinBox2" );
    SITSpinBox2->setGeometry( QRect( 175, 40, 50, 20 ) ); 
    SITSpinBox2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, SITSpinBox2->sizePolicy().hasHeightForWidth() ) );
    QFont SITSpinBox2_font(  SITSpinBox2->font() );
    SITSpinBox2_font.setBold( FALSE );
    SITSpinBox2->setFont( SITSpinBox2_font ); 
    SITSpinBox2->setWrapping( FALSE );
    SITSpinBox2->setMaxValue( SIT_MAX );
    SITSpinBox2->setValue( 0 );

    ADTSpinBox2 = new QSpinBox( DiveGroupBox2, "ADTSpinBox2" );
    ADTSpinBox2->setGeometry( QRect( 175, 15, 50, 20 ) ); 
    ADTSpinBox2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, ADTSpinBox2->sizePolicy().hasHeightForWidth() ) );
    QFont ADTSpinBox2_font(  ADTSpinBox2->font() );
    ADTSpinBox2_font.setBold( FALSE );
    ADTSpinBox2->setFont( ADTSpinBox2_font ); 
    ADTSpinBox2->setWrapping( FALSE );
    ADTSpinBox2->setMaxValue( ADT_MAX );
    ADTSpinBox2->setValue( 0 );

    ADTTextLabel2 = new QLabel( DiveGroupBox2, "ADTTextLabel2" );
    ADTTextLabel2->setGeometry( QRect( 145, 15, 30, 20 ) ); 
    QFont ADTTextLabel2_font(  ADTTextLabel2->font() );
    ADTTextLabel2_font.setBold( FALSE );
    ADTTextLabel2->setFont( ADTTextLabel2_font ); 
    ADTTextLabel2->setText( tr( "ADT" ) );
    QToolTip::add(  ADTTextLabel2, tr( "Actual Dive Time" ) );

    ftmTextLabel2 = new QLabel( DiveGroupBox2, "ftmTextLabel2" );
    ftmTextLabel2->setGeometry( QRect( 120, 15, 16, 16 ) ); 
    QFont ftmTextLabel2_font(  ftmTextLabel2->font() );
    ftmTextLabel2_font.setBold( FALSE );
    ftmTextLabel2->setFont( ftmTextLabel2_font ); 
    ftmTextLabel2->setText( tr( "ft." ) );

    DepthSpinBox2 = new QSpinBox( DiveGroupBox2, "DepthSpinBox2" );
    DepthSpinBox2->setGeometry( QRect( 65, 15, 50, 20 ) ); 
    DepthSpinBox2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, DepthSpinBox2->sizePolicy().hasHeightForWidth() ) );
    QFont DepthSpinBox2_font(  DepthSpinBox2->font() );
    DepthSpinBox2_font.setBold( FALSE );
    DepthSpinBox2->setFont( DepthSpinBox2_font ); 
    DepthSpinBox2->setWrapping( FALSE );
    DepthSpinBox2->setMaxValue( DEPTH_MAX );
    DepthSpinBox2->setValue( 0 );

    DepthTextLabel2 = new QLabel( DiveGroupBox2, "DepthTextLabel2" );
    DepthTextLabel2->setGeometry( QRect( 20, 15, 40, 16 ) ); 
    QFont DepthTextLabel2_font(  DepthTextLabel2->font() );
    DepthTextLabel2_font.setBold( FALSE );
    DepthTextLabel2->setFont( DepthTextLabel2_font ); 
    DepthTextLabel2->setText( tr( "Depth:" ) );

    DiveGroupBox3 = new QGroupBox( this, "DiveGroupBox3" );
    DiveGroupBox3->setGeometry( QRect( 5, 165, 230, 70 ) ); 
    QFont DiveGroupBox3_font(  DiveGroupBox3->font() );
    DiveGroupBox3_font.setBold( TRUE );
    DiveGroupBox3->setFont( DiveGroupBox3_font ); 
    DiveGroupBox3->setTitle( tr( "Dive 3" ) );
    DiveGroupBox3->setAlignment( int( QGroupBox::AlignLeft ) );

    RNTTextLabel3 = new QLabel( DiveGroupBox3, "RNTTextLabel3" );
    RNTTextLabel3->setGeometry( QRect( 10, 40, 30, 20 ) ); 
    QFont RNTTextLabel3_font(  RNTTextLabel3->font() );
    RNTTextLabel3_font.setBold( FALSE );
    RNTTextLabel3->setFont( RNTTextLabel3_font ); 
    RNTTextLabel3->setText( tr( "RNT" ) );
    QToolTip::add(  RNTTextLabel3, tr( "Residual Nitrogen Time" ) );

    RNTLineEdit3 = new QLineEdit( DiveGroupBox3, "RNTLineEdit3" );
    RNTLineEdit3->setGeometry( QRect( 40, 40, 31, 22 ) ); 
    QFont RNTLineEdit3_font(  RNTLineEdit3->font() );
    RNTLineEdit3_font.setBold( FALSE );
    RNTLineEdit3->setFont( RNTLineEdit3_font ); 
    RNTLineEdit3->setFocusPolicy( QLineEdit::NoFocus );
    RNTLineEdit3->setText( tr( "0" ) );
    RNTLineEdit3->setFrame( FALSE );
    RNTLineEdit3->setAlignment( int( QLineEdit::AlignHCenter ) );

    TNTTextLabel3 = new QLabel( DiveGroupBox3, "TNTTextLabel3" );
    TNTTextLabel3->setGeometry( QRect( 80, 40, 30, 20 ) ); 
    QFont TNTTextLabel3_font(  TNTTextLabel3->font() );
    TNTTextLabel3_font.setBold( FALSE );
    TNTTextLabel3->setFont( TNTTextLabel3_font ); 
    TNTTextLabel3->setText( tr( "TNT" ) );
    QToolTip::add(  TNTTextLabel3, tr( "Total Nitrogen Time" ) );

    TNTLineEdit3 = new QLineEdit( DiveGroupBox3, "TNTLineEdit3" );
    TNTLineEdit3->setGeometry( QRect( 110, 40, 31, 22 ) ); 
    QFont TNTLineEdit3_font(  TNTLineEdit3->font() );
    TNTLineEdit3_font.setBold( FALSE );
    TNTLineEdit3->setFont( TNTLineEdit3_font ); 
    TNTLineEdit3->setFocusPolicy( QLineEdit::NoFocus );
    TNTLineEdit3->setAutoMask( FALSE );
    TNTLineEdit3->setText( tr( "0" ) );
    TNTLineEdit3->setFrame( FALSE );
    TNTLineEdit3->setAlignment( int( QLineEdit::AlignHCenter ) );

    ftmTextLabel3 = new QLabel( DiveGroupBox3, "ftmTextLabel3" );
    ftmTextLabel3->setGeometry( QRect( 120, 15, 16, 16 ) ); 
    QFont ftmTextLabel3_font(  ftmTextLabel3->font() );
    ftmTextLabel3_font.setBold( FALSE );
    ftmTextLabel3->setFont( ftmTextLabel3_font ); 
    ftmTextLabel3->setText( tr( "ft." ) );

    ADTTextLabel3 = new QLabel( DiveGroupBox3, "ADTTextLabel3" );
    ADTTextLabel3->setGeometry( QRect( 145, 15, 30, 20 ) ); 
    QFont ADTTextLabel3_font(  ADTTextLabel3->font() );
    ADTTextLabel3_font.setBold( FALSE );
    ADTTextLabel3->setFont( ADTTextLabel3_font ); 
    ADTTextLabel3->setText( tr( "ADT" ) );
    QToolTip::add(  ADTTextLabel3, tr( "Actual Dive Time" ) );

    ADTSpinBox3 = new QSpinBox( DiveGroupBox3, "ADTSpinBox3" );
    ADTSpinBox3->setGeometry( QRect( 175, 15, 50, 20 ) ); 
    ADTSpinBox3->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, ADTSpinBox3->sizePolicy().hasHeightForWidth() ) );
    QFont ADTSpinBox3_font(  ADTSpinBox3->font() );
    ADTSpinBox3_font.setBold( FALSE );
    ADTSpinBox3->setFont( ADTSpinBox3_font ); 
    ADTSpinBox3->setWrapping( FALSE );
    ADTSpinBox3->setMaxValue( ADT_MAX );
    ADTSpinBox3->setValue( 0 );

    SITTextLabel3 = new QLabel( DiveGroupBox3, "SITTextLabel3" );
    SITTextLabel3->setGeometry( QRect( 150, 40, 20, 20 ) ); 
    QFont SITTextLabel3_font(  SITTextLabel3->font() );
    SITTextLabel3_font.setBold( FALSE );
    SITTextLabel3->setFont( SITTextLabel3_font ); 
    SITTextLabel3->setText( tr( "SIT" ) );
    QToolTip::add(  SITTextLabel3, tr( "Surface Interval Time" ) );

    SITSpinBox3 = new QSpinBox( DiveGroupBox3, "SITSpinBox3" );
    SITSpinBox3->setGeometry( QRect( 175, 40, 50, 20 ) ); 
    SITSpinBox3->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, SITSpinBox3->sizePolicy().hasHeightForWidth() ) );
    QFont SITSpinBox3_font(  SITSpinBox3->font() );
    SITSpinBox3_font.setBold( FALSE );
    SITSpinBox3->setFont( SITSpinBox3_font ); 
    SITSpinBox3->setWrapping( FALSE );
    SITSpinBox3->setMaxValue( SIT_MAX );
    SITSpinBox3->setValue( 0 );

    DepthSpinBox3 = new QSpinBox( DiveGroupBox3, "DepthSpinBox3" );
    DepthSpinBox3->setGeometry( QRect( 65, 15, 50, 20 ) ); 
    DepthSpinBox3->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, DepthSpinBox3->sizePolicy().hasHeightForWidth() ) );
    QFont DepthSpinBox3_font(  DepthSpinBox3->font() );
    DepthSpinBox3_font.setBold( FALSE );
    DepthSpinBox3->setFont( DepthSpinBox3_font ); 
    DepthSpinBox3->setWrapping( FALSE );
    DepthSpinBox3->setMaxValue( DEPTH_MAX );
    DepthSpinBox3->setValue( 0 );

    DepthTextLabel3 = new QLabel( DiveGroupBox3, "DepthTextLabel3" );
    DepthTextLabel3->setGeometry( QRect( 20, 15, 40, 16 ) ); 
    QFont DepthTextLabel3_font(  DepthTextLabel3->font() );
    DepthTextLabel3_font.setBold( FALSE );
    DepthTextLabel3->setFont( DepthTextLabel3_font ); 
    DepthTextLabel3->setText( tr( "Depth:" ) );

    // signals and slots connections
    connect( CalculatePushButton, SIGNAL( clicked() ), this, SLOT( slotCalculate() ) );
    connect( PrefsPushButton, SIGNAL( clicked() ), this, SLOT( slotPrefs() ) );
    connect( ClearPushButton, SIGNAL( clicked() ), this, SLOT( slotClear() ) );

    // tab order
    setTabOrder( DepthSpinBox1, ADTSpinBox1 );
    setTabOrder( ADTSpinBox1, SITSpinBox1 );
    setTabOrder( SITSpinBox1, DepthSpinBox2 );
    setTabOrder( DepthSpinBox2, ADTSpinBox2 );
    setTabOrder( ADTSpinBox2, SITSpinBox2 );
    setTabOrder( SITSpinBox2, DepthSpinBox3 );
    setTabOrder( DepthSpinBox3, ADTSpinBox3 );
    setTabOrder( ADTSpinBox3, SITSpinBox3 );
    setTabOrder( SITSpinBox3, CalculatePushButton );
    setTabOrder( CalculatePushButton, ClearPushButton );
    setTabOrder( ClearPushButton, PrefsPushButton );
    setTabOrder( PrefsPushButton, RNTLineEdit1 );
    setTabOrder( RNTLineEdit1, RNTLineEdit2 );
    setTabOrder( RNTLineEdit2, RNTLineEdit3 );


//bad software warning ;-)
/*
QMessageBox::warning( this, "DiveCalc Warning!",
	"This program is ALPHA software \n"
	"and most certainly contains \n"
	"MANY ERRORS in it. DO NOT use \n"
	"it for planning dives under any \n"
	"circumstances! Check \n\n"
	"  http://divecalc.narced.com \n\n"
	"for updates. \n\n"
	"-Ed " );
*/

}//end DiveCalcBase::

/*  
 *  Destroys the object and frees any allocated resources
 */
DiveCalcBase::~DiveCalcBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*  
 *  Main event handler. Reimplemented to handle application
 *  font changes
 */
bool DiveCalcBase::event( QEvent* ev )
{
    bool ret = QWidget::event( ev ); 
    if ( ev->type() == QEvent::ApplicationFontChange ) {
	QFont AMDTGroupBox_font(  AMDTGroupBox->font() );
	AMDTGroupBox_font.setBold( TRUE );
	AMDTGroupBox->setFont( AMDTGroupBox_font ); 
	QFont CalculatePushButton_font(  CalculatePushButton->font() );
	CalculatePushButton->setFont( CalculatePushButton_font ); 
	QFont AMDTLineEdit_font(  AMDTLineEdit->font() );
	AMDTLineEdit_font.setPointSize( 14 );
	AMDTLineEdit_font.setBold( FALSE );
	AMDTLineEdit->setFont( AMDTLineEdit_font ); 
	QFont PrefsPushButton_font(  PrefsPushButton->font() );
	PrefsPushButton_font.setBold( FALSE );
	PrefsPushButton->setFont( PrefsPushButton_font ); 
	QFont ClearPushButton_font(  ClearPushButton->font() );
	ClearPushButton_font.setBold( FALSE );
	ClearPushButton->setFont( ClearPushButton_font ); 
	QFont DiveGroupBox1_font(  DiveGroupBox1->font() );
	DiveGroupBox1_font.setBold( TRUE );
	DiveGroupBox1->setFont( DiveGroupBox1_font ); 
	QFont SITSpinBox1_font(  SITSpinBox1->font() );
	SITSpinBox1_font.setBold( FALSE );
	SITSpinBox1->setFont( SITSpinBox1_font ); 
	QFont SITTextLabel1_font(  SITTextLabel1->font() );
	SITTextLabel1_font.setBold( FALSE );
	SITTextLabel1->setFont( SITTextLabel1_font ); 
	QFont TNTLineEdit1_font(  TNTLineEdit1->font() );
	TNTLineEdit1_font.setBold( FALSE );
	TNTLineEdit1->setFont( TNTLineEdit1_font ); 
	QFont TNTTextLabel1_font(  TNTTextLabel1->font() );
	TNTTextLabel1_font.setBold( FALSE );
	TNTTextLabel1->setFont( TNTTextLabel1_font ); 
	QFont RNTLineEdit1_font(  RNTLineEdit1->font() );
	RNTLineEdit1_font.setBold( FALSE );
	RNTLineEdit1->setFont( RNTLineEdit1_font ); 
	QFont RNTTextLabel1_font(  RNTTextLabel1->font() );
	RNTTextLabel1_font.setBold( FALSE );
	RNTTextLabel1->setFont( RNTTextLabel1_font ); 
	QFont ADTTextLabel1_font(  ADTTextLabel1->font() );
	ADTTextLabel1_font.setBold( FALSE );
	ADTTextLabel1->setFont( ADTTextLabel1_font ); 
	QFont ADTSpinBox1_font(  ADTSpinBox1->font() );
	ADTSpinBox1_font.setBold( FALSE );
	ADTSpinBox1->setFont( ADTSpinBox1_font ); 
	QFont ftmTextLabel1_font(  ftmTextLabel1->font() );
	ftmTextLabel1_font.setBold( FALSE );
	ftmTextLabel1->setFont( ftmTextLabel1_font ); 
	QFont DepthTextLabel1_font(  DepthTextLabel1->font() );
	DepthTextLabel1_font.setBold( FALSE );
	DepthTextLabel1->setFont( DepthTextLabel1_font ); 
	QFont DepthSpinBox1_font(  DepthSpinBox1->font() );
	DepthSpinBox1_font.setBold( FALSE );
	DepthSpinBox1->setFont( DepthSpinBox1_font ); 
	QFont DiveGroupBox2_font(  DiveGroupBox2->font() );
	DiveGroupBox2_font.setBold( TRUE );
	DiveGroupBox2->setFont( DiveGroupBox2_font ); 
	QFont RNTTextLabel2_font(  RNTTextLabel2->font() );
	RNTTextLabel2_font.setBold( FALSE );
	RNTTextLabel2->setFont( RNTTextLabel2_font ); 
	QFont RNTLineEdit2_font(  RNTLineEdit2->font() );
	RNTLineEdit2_font.setBold( FALSE );
	RNTLineEdit2->setFont( RNTLineEdit2_font ); 
	QFont TNTTextLabel2_font(  TNTTextLabel2->font() );
	TNTTextLabel2_font.setBold( FALSE );
	TNTTextLabel2->setFont( TNTTextLabel2_font ); 
	QFont TNTLineEdit2_font(  TNTLineEdit2->font() );
	TNTLineEdit2_font.setBold( FALSE );
	TNTLineEdit2->setFont( TNTLineEdit2_font ); 
	QFont SITTextLabel2_font(  SITTextLabel2->font() );
	SITTextLabel2_font.setBold( FALSE );
	SITTextLabel2->setFont( SITTextLabel2_font ); 
	QFont SITSpinBox2_font(  SITSpinBox2->font() );
	SITSpinBox2_font.setBold( FALSE );
	SITSpinBox2->setFont( SITSpinBox2_font ); 
	QFont ADTSpinBox2_font(  ADTSpinBox2->font() );
	ADTSpinBox2_font.setBold( FALSE );
	ADTSpinBox2->setFont( ADTSpinBox2_font ); 
	QFont ADTTextLabel2_font(  ADTTextLabel2->font() );
	ADTTextLabel2_font.setBold( FALSE );
	ADTTextLabel2->setFont( ADTTextLabel2_font ); 
	QFont ftmTextLabel2_font(  ftmTextLabel2->font() );
	ftmTextLabel2_font.setBold( FALSE );
	ftmTextLabel2->setFont( ftmTextLabel2_font ); 
	QFont DepthSpinBox2_font(  DepthSpinBox2->font() );
	DepthSpinBox2_font.setBold( FALSE );
	DepthSpinBox2->setFont( DepthSpinBox2_font ); 
	QFont DepthTextLabel2_font(  DepthTextLabel2->font() );
	DepthTextLabel2_font.setBold( FALSE );
	DepthTextLabel2->setFont( DepthTextLabel2_font ); 
	QFont DiveGroupBox3_font(  DiveGroupBox3->font() );
	DiveGroupBox3_font.setBold( TRUE );
	DiveGroupBox3->setFont( DiveGroupBox3_font ); 
	QFont RNTTextLabel3_font(  RNTTextLabel3->font() );
	RNTTextLabel3_font.setBold( FALSE );
	RNTTextLabel3->setFont( RNTTextLabel3_font ); 
	QFont RNTLineEdit3_font(  RNTLineEdit3->font() );
	RNTLineEdit3_font.setBold( FALSE );
	RNTLineEdit3->setFont( RNTLineEdit3_font ); 
	QFont TNTTextLabel3_font(  TNTTextLabel3->font() );
	TNTTextLabel3_font.setBold( FALSE );
	TNTTextLabel3->setFont( TNTTextLabel3_font ); 
	QFont TNTLineEdit3_font(  TNTLineEdit3->font() );
	TNTLineEdit3_font.setBold( FALSE );
	TNTLineEdit3->setFont( TNTLineEdit3_font ); 
	QFont ftmTextLabel3_font(  ftmTextLabel3->font() );
	ftmTextLabel3_font.setBold( FALSE );
	ftmTextLabel3->setFont( ftmTextLabel3_font ); 
	QFont ADTTextLabel3_font(  ADTTextLabel3->font() );
	ADTTextLabel3_font.setBold( FALSE );
	ADTTextLabel3->setFont( ADTTextLabel3_font ); 
	QFont ADTSpinBox3_font(  ADTSpinBox3->font() );
	ADTSpinBox3_font.setBold( FALSE );
	ADTSpinBox3->setFont( ADTSpinBox3_font ); 
	QFont SITTextLabel3_font(  SITTextLabel3->font() );
	SITTextLabel3_font.setBold( FALSE );
	SITTextLabel3->setFont( SITTextLabel3_font ); 
	QFont SITSpinBox3_font(  SITSpinBox3->font() );
	SITSpinBox3_font.setBold( FALSE );
	SITSpinBox3->setFont( SITSpinBox3_font ); 
	QFont DepthSpinBox3_font(  DepthSpinBox3->font() );
	DepthSpinBox3_font.setBold( FALSE );
	DepthSpinBox3->setFont( DepthSpinBox3_font ); 
	QFont DepthTextLabel3_font(  DepthTextLabel3->font() );
	DepthTextLabel3_font.setBold( FALSE );
	DepthTextLabel3->setFont( DepthTextLabel3_font ); 
    }
    return ret;
}

void DiveCalcBase::slotPrefs()
{
    qWarning( "DiveCalcBase::slotPrefs(): Button Disabled!" );
}

void DiveCalcBase::slotCalculate()
{

int	amdt=0,
	rnt1=0, rnt2=0, rnt3=0,
	tnt1=0, tnt2=0, tnt3=0,
	dive1depthindex=0, dive2depthindex=0, dive3depthindex=0,
	dive1group=0, dive2group=0, dive3group=0,
	sit1dive2group=0, sit2dive3group=0;

//qWarning( "DiveCalcBase::slotCalculate(): Calculating..." );


//------------Dive1----------------
if ( DepthSpinBox1->value() > 0 ) {

	qWarning( "Calculating Dive 1" );

	//find amdt of dive 1
	dive1depthindex = get_depth_index(DepthSpinBox1->value());
	amdt = get_mdt( dive1depthindex );

	if ( ADTSpinBox1->value() > amdt ) {
		//alert warning
		QMessageBox::warning( this, "DiveCalc Warning!",
			"ADT(1) exceeds (A)MDT! \n"
			"Please enter a new ADT." );
		ADTSpinBox1->setValue( 0 );
	} //end if adt > amdt

	//copy text from RNTLineEdit1 into rnt1 integer
	//used in case RNT1 is ever made editable
	//sscanf(RNTLineEdit1->text(), "%d", &rnt1);
	rnt1 = 0;
	tnt1 = rnt1 + ADTSpinBox1->value();
	TNTLineEdit1->setText( QString::number(tnt1) );

}//end if
//------------Dive1----------------



//------------Dive1+Dive2----------------
if (( DepthSpinBox1->value() > 0 ) && ( DepthSpinBox2->value() > 0 )) {

//	qWarning( "Calculating Dive 2" );

	//find amdt of dive 2
	dive1group = get_t1_group( get_depth_index(DepthSpinBox1->value()) , tnt1 );
	sit1dive2group = sit_lookup( dive1group , SITSpinBox1->value() );
	dive2depthindex = get_depth_index(DepthSpinBox2->value());
	amdt = get_amdt( sit1dive2group , dive2depthindex );

	//find rnt of dive 2
	rnt2 = get_rnt( sit1dive2group , dive2depthindex );
	RNTLineEdit2->setText( QString::number(rnt2) );

	if ( ADTSpinBox2->value() > amdt ) {
		//alert warning
		QMessageBox::warning( this, "DiveCalc Warning!",
			"ADT(2) exceeds (A)MDT! \n"
			"Please enter a new ADT." );
		ADTSpinBox2->setValue( 0 );
	} //end if adt > amdt

	tnt2 = rnt2 + ADTSpinBox2->value();
	TNTLineEdit2->setText( QString::number(tnt2) );

}//end if
//------------Dive1+Dive2----------------



//------------Dive1+Dive2+Dive3----------------
if (( DepthSpinBox1->value() > 0 ) && ( DepthSpinBox2->value() > 0 ) && ( DepthSpinBox3->value() > 0 )) {

//	qWarning( "Calculating Dive 3" );

	//find amdt of dive 3
	dive2group = get_t1_group( get_depth_index(DepthSpinBox2->value()) , tnt2 );
	sit2dive3group = sit_lookup( dive2group , SITSpinBox2->value() );
	dive3depthindex = get_depth_index(DepthSpinBox3->value());
	amdt = get_amdt( sit2dive3group , dive3depthindex );

	//find rnt of dive 3
	rnt3 = get_rnt( sit2dive3group , dive3depthindex );
	RNTLineEdit3->setText( QString::number(rnt3) );

	if ( ADTSpinBox3->value() > amdt ) {
		//alert warning
		QMessageBox::warning( this, "DiveCalc Warning!",  
			"ADT(3) exceeds (A)MDT! \n"
			"Please enter a new ADT." );
		ADTSpinBox3->setValue( 0 ); 
	} //end if adt > amdt  

	tnt3 = rnt3 + ADTSpinBox3->value();
	TNTLineEdit3->setText( QString::number(tnt3) );

}//end if
//------------Dive1+Dive2+Dive3----------------


//print to screen after all calcs done
AMDTLineEdit->setText( QString::number(amdt) );


/* PSEUDO-CODE
 * if (depth1 > 0) {
 *	get max dive time
 *	if adt > amdt,
 *	   alert warning
 *	   adt1=0
 *	else
 *	   tnt1 = rnt1 + adt1
 * }//end if depth1
 *
 * if ((depth1 > 0) && (depth2 > 0)) {
 *	   sit lookup
 *	   get amdt of dive2
 *	   get rnt2
 *	if adt2 > amdt
 *	   alert warning
 *	   atd2=0
 *	else
 *	  tnt2 = rnt2 + adt2
 *
 * }//end if depth1 && depth2
 *
 * if ((depth1 > 0) && (depth2 > 0) && (depth3 > 0)) {
 *	sit lookup
 *	get amdt of dive3
 *	if adt3 > amdt
 *	   alert warning
 *	   adt3=0
 *	else
 *	   get rnt3
 *	tnt3 = rnt3 + adt3
 *
 * }//end if depth1 && depth2 && depth3
 */

}//end slotCalculate



void DiveCalcBase::slotClear()
{
    qWarning( "DiveCalcBase::slotClear(): Resetting values to 0!" );

    AMDTLineEdit->setText( tr( "0" ) );

    DepthSpinBox1->setValue( 0 );
    ADTSpinBox1->setValue( 0 );
    RNTLineEdit1->setText( tr( "0" ) );
    TNTLineEdit1->setText( tr( "0" ) );
    SITSpinBox1->setValue( 0 );

    DepthSpinBox2->setValue( 0 );
    ADTSpinBox2->setValue( 0 );
    RNTLineEdit2->setText( tr( "0" ) );
    TNTLineEdit2->setText( tr( "0" ) );
    SITSpinBox2->setValue( 0 );

    DepthSpinBox3->setValue( 0 );
    ADTSpinBox3->setValue( 0 );
    RNTLineEdit3->setText( tr( "0" ) );
    TNTLineEdit3->setText( tr( "0" ) );
    SITSpinBox3->setValue( 0 );
}//end clear


void DiveCalcBase::slotHelp()
{
    qWarning( "DiveCalcBase::slotHelp(): Help" );
//QMessageBox helpmb( this, "DiveCalc Help",
//			"I first wrote DiveCalc for PalmOS\n"
//			"as my Senior Project in college.\n"
//			"I released it on PalmGear.com and\n"
//			"to my surprise, it became very popular.\n"
//		QMessageBox::NoIcon,
//		QMessageBox::Ok,  );
//
//helpmb.exec();

}

void DiveCalcBase::slotDefinitions()
{
    qWarning( "DiveCalcBase::slotDefinitions(): Not implemented yet!" );
}

void DiveCalcBase::slotLicense()
{
    qWarning( "DiveCalcBase::slotLicense(): Not implemented yet!" );
}

void DiveCalcBase::slotAbout()
{
    qWarning( "DiveCalcBase::slotAbout(): About DiveCalc" );
//see file:///opt/Qtopia/doc/qt/html/qmessagebox.html

QMessageBox::about( this, "About DiveCalc",
			"DiveCalc version 0.0 BETA\n"
			"By Ed Negari\n\n"
			"http://divecalc.narced.com\n");

}
